<?php
/* $Id: index.php,v 1.7 2003/11/03 15:50:26 k-fish Exp $ */

$myEnv["module"] = "notes";
$myEnv["output"] = "html";

require_once("../../config.inc.php");
require_once(INCLUDEPATH . "container.inc.php");
require_once("inc/note.class.php");
require_once("inc/category.class.php");

// adding file revision into global array
revisionInit("\$Revision: 1.7 $", __FILE__);

// fixing missing obj variable until mgw provides this.
if((!isset($_GET["obj"]) && !isset($_POST["obj"]))
   || ($_GET["obj"]=='' && $_POST["obj"]==''))
     $_GET["obj"] = "note";

// ==================================================================================================
// note handling
// ==================================================================================================
// ==================================================================================================
if($_GET["obj"] == "note" || $_POST["obj"] == "note"){
    $noteObj = new Note();

    if ($_POST["op"] == "create"){
	$noteObj->opCreate();
    }

    if ($_POST["op"] == "docomment"){
	$noteObj->opComment();
	$_GET['view'] = 'details';
	$_GET["id"] = $_POST['note_id'];
    }

    if ($_POST["op"] == "editcomment"){
	$id = (int) $_POST["cid"];
	$noteObj->editComment($id);
	$_GET['view'] = 'details';
	$_GET["id"] = $_POST['note_id'];
    }

    if($_POST["op"] == "edit"){
	$id = (int) $_POST["id"];
	$noteObj->opUpdate($id);
	$_GET['view'] = 'editform';
	$_GET["id"] = $id;
    }
   
    if ($_GET["view"] == "newform") {
	$noteObj->viewNewForm();
	exit();
    }

    if ($_GET["view"] == "editform") {
	$id = (int) $_GET["id"];
	$noteObj->viewEditForm($id);
	exit();
    }

    if($_GET["view"] == "details"){
	$id = (int) $_GET["id"];
	$noteObj->viewDetails($id);
	exit();
    }

    if(isset($_POST["confirmation_yes"])) {
	$id = (int) $_POST["itemid"];
	$noteObj->opDelete($id);
    }
    elseif ($_GET["view"] == "delete"){
	$id = (int) $_GET["id"];
	$noteObj->viewDelete($id);
	exit();
    }

    $noteObj->viewList();
    exit();
}

// ==================================================================================================
// category handling
// ==================================================================================================
// ==================================================================================================
if($_GET["obj"] == "category" || $_POST["obj"] == "category"){
    $catObj = new Category();

    if ($_POST["op"] == "create"){
	$catObj->opCreate();
    }

    if($_POST["op"] == "edit"){
	$catObj->opUpdate();
    }
   
    if ($_GET["view"] == "newform") {
	$catObj->viewNewForm();
	exit();
    }

    if ($_GET["view"] == "editform") {
	$id = (int) $_GET["id"];
	$catObj->viewEditForm($id);
	exit();
    }

    if($_GET["view"] == "details"){
	$id = (int) $_GET["id"];
	$catObj->viewDetails($id);
	exit();
    }

    if(isset($_POST["confirmation_yes"])) {
	$id = (int) $_POST["itemid"];
	$catObj->opDelete($id);
    }
    elseif ($_GET["view"] == "delete"){
	$id = (int) $_GET["id"];
	$catObj->viewDelete($id);
	exit();
    }

    $catObj->viewList();
    exit();
}

?>